# -*- coding: utf-8 -*-
from setuphelpers import *


"""
[
    {
        "key": "{3C31CBA1-A0D9-4B95-A807-AD2313D12F47}",
        "name": "Microsoft Windows Desktop Runtime - 5.0.17 (x64)",
        "version": "40.68.31219",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{3C31CBA1-A0D9-4B95-A807-AD2313D12F47}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{5A66E598-37BD-4C8A-A7CB-A71C32ABCD78}",
        "name": "Microsoft .NET Runtime - 5.0.17 (x64)",
        "version": "40.68.31213",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{5A66E598-37BD-4C8A-A7CB-A71C32ABCD78}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{8BA25391-0BE6-443A-8EBF-86A29BAFC479}",
        "name": "Microsoft .NET Host FX Resolver - 5.0.17 (x64)",
        "version": "40.68.31213",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{8BA25391-0BE6-443A-8EBF-86A29BAFC479}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{E663ED1E-899C-40E8-91D0-8D37B95E3C69}",
        "name": "Microsoft .NET Host - 5.0.17 (x64)",
        "version": "40.68.31213",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{E663ED1E-899C-40E8-91D0-8D37B95E3C69}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{098c6ff7-1af1-4c4a-b86f-c60608c98e31}",
        "name": "Microsoft Windows Desktop Runtime - 5.0.17 (x86)",
        "version": "5.0.17.31219",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{098c6ff7-1af1-4c4a-b86f-c60608c98e31}\\windowsdesktop-runtime-5.0.17-win-x86.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{0D02D706-44F2-4957-A448-E7259A0B56B9}",
        "name": "Microsoft Windows Desktop Runtime - 5.0.17 (x86)",
        "version": "40.68.31219",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{0D02D706-44F2-4957-A448-E7259A0B56B9}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{20d5df4e-006c-4d6d-a0dc-490d009b9786}",
        "name": "Microsoft Windows Desktop Runtime - 5.0.17 (x64)",
        "version": "5.0.17.31219",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{20d5df4e-006c-4d6d-a0dc-490d009b9786}\\windowsdesktop-runtime-5.0.17-win-x64.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{54DE7EA9-E391-4BD2-A373-3A72A18EBDB5}",
        "name": "Microsoft .NET Host - 5.0.17 (x86)",
        "version": "40.68.31213",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{54DE7EA9-E391-4BD2-A373-3A72A18EBDB5}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{59650A2A-3839-46EC-9D9C-6B3B1C743C55}",
        "name": "Microsoft .NET Runtime - 5.0.17 (x86)",
        "version": "40.68.31213",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{59650A2A-3839-46EC-9D9C-6B3B1C743C55}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{AF01038B-6523-4EA7-9D9E-4F1E2927D88B}",
        "name": "Microsoft .NET Host FX Resolver - 5.0.17 (x86)",
        "version": "40.68.31213",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{AF01038B-6523-4EA7-9D9E-4F1E2927D88B}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
]


"""


def install():
    dotnet_version = control.get_software_version().split(".")[0]

    # Installing the software
    silentflags = "/install /quiet /norestart"
    if iswin64():
        install_exe_if_needed(
            glob.glob("windowsdesktop-runtime-*x64.exe")[0],
            silentflags=silentflags,
            name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x64)",
            min_version="",
            force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
        )
    install_exe_if_needed(
        glob.glob("windowsdesktop-runtime-*x86.exe")[0],
        silentflags=silentflags,
        name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x86)",
        min_version="",
        force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
    )

    # Clear uninstallkey to avoid the no-code audit and uninstall
    uninstallkey.clear()


def audit():
    # Declaring local variables
    audit_result = "OK"
    dotnet_version = control.get_software_version().split(".")[0]
    app_check = installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*")
    audit_version = True

    # Auditing software
    if not app_check:
        print("%s is not installed" % control.package.split("-", 1)[-1].replace("-", " ").title())
        audit_result = "ERROR"
    elif audit_version:
        for to_audit in app_check:
            if r"ProgramData\Package Cache" in to_audit["uninstall_string"]:
                if Version(to_audit["version"]) < Version(control.get_software_version()):
                    print(f'{to_audit["name"]} is installed in version: {to_audit["version"]} instead of: {control.get_software_version()}.')
                    audit_result = "WARNING"
                else:
                    print("%s is installed and up-to-date." % to_audit["name"])

    return audit_result


def uninstall():
    # Declaring local variables
    dotnet_version = control.get_software_version().split(".")[0]

    for to_uninstall in installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*"):
        if r"ProgramData\Package Cache" in to_uninstall["uninstall_string"]:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]) + " /norestart")
            wait_uninstallkey_absent(to_uninstall["key"])
            if isdir(to_uninstall["install_location"]):
                remove_tree(to_uninstall["install_location"])
